// test.cpp
// Testing Framework
// Copyright (c) 2001 Tsutomu Saito All Rights Reserved

#include "test.h"
#include <time.h>

int CTest::Run(const char* caseName)
{
	int				nRuns,nFail,nErr;
	node_iterator	it;
	clock_t			t = clock();
	char			buf[256],c;
	m_message = "";
	nRuns = nFail = nErr = 0;
	for (it=m_tree.begin();it!=m_tree.end();++it)
		if (*it) ++nRuns;
	for (it=m_tree.begin();it!=m_tree.end();++it) {
		if (!*it) continue;
		c = '.';
		try {
		(*it)->RunTest(caseName);
		} catch (CTestException e) {
			sprintf(buf,"%s(%d) : %s : %s\n",e.File(),e.Line(),
				(*it)->TestName(),e.Express());
			m_message += buf;
			c = 'F';
			++nFail;
		} catch (const char* p) {
			m_message += p;
			m_message += '\n';
			c = 'E';
			++nErr;
		} catch (...) {
			c = 'E';
			++nErr;
		}
		fprintf(stderr,"%c",c);
	}
	fprintf(stderr,"\n");
	sprintf(buf,"%d Runs  %d Failures  %d Errors\nTime: %g sec\n",
		nRuns,nFail,nErr, (double)(clock() - t) / CLOCKS_PER_SEC);
	m_message += buf;
	return nFail + nErr;
}

CTest::node_iterator AddTest(CTest& t,CTestFunc f,
		CTest::node_iterator it, const char* name = "")
{
	return t.AddTest(new CTestCaseFunc(f,name),it);
}

